Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® Application Server XML Java API Reference 10g Release 2 (10.1.2) Part no. B12024-03 September 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.xml.sax
Interface EntityResolver

All Known Implementing Classes:
  DefaultHandler, HandlerBase, XMLFilterImpl

public interface EntityResolver

Basic interface for resolving entities.

> This module, both source code and documentation, is in the Public Domain, and comes with NO WARRANTY.

If a SAX application needs to implement customized handling for external entities, it must implement this interface and register an instance with the SAX driver using the `setEntityResolver` method.

The XML reader will then allow the application to intercept any external entities (including the external DTD subset and external parameter entities, if any) before including them.

Many SAX applications will not need to implement this interface, but it will be especially useful for applications that build XML documents from databases or other specialised input sources, or for applications that use URI types other than URLs.

The following resolver would provide the application with a special character stream for the entity with the system identifier "http://www.myhost.com/today":

     import org.xml.sax.EntityResolver;
     import org.xml.sax.InputSource;

     public class MyResolver implements EntityResolver {
       public InputSource resolveEntity (String publicId, String systemId)
       {
         if (systemId.equals("http://www.myhost.com/today")) {
                  // return a special input source
           MyReader reader = new MyReader();
           return new InputSource(reader);
         } else {
                  // use the default behaviour
           return null;
         }
       }
     }

The application can also use this interface to redirect system identifiers to local URIs or to look up replacements in a catalog (possibly by using the public identifier).

Since:
  SAX 1.0
See Also:
  `Parser.setEntityResolver(org.xml.sax.EntityResolver)`, `InputSource`

Method Summary
`InputSource` | `resolveEntity(java.lang.String publicId, java.lang.String systemId)` Allow the application to resolve external entities.

Method Detail

### resolveEntity

    public InputSource resolveEntity(java.lang.String publicId,
                                     java.lang.String systemId)
                              throws SAXException,
                                     java.io.IOException

  Allow the application to resolve external entities.

  The Parser will call this method before opening any external entity except the top-level document entity (including the external DTD subset, external entities referenced within the DTD, and external entities referenced within the document element): the application may request that the parser resolve the entity itself, that it use an alternative URI, or that it use an entirely different input source.

  Application writers can use this method to redirect external system identifiers to secure and/or local URIs, to look up public identifiers in a catalogue, or to read an entity from a database or other input source (including, for example, a dialog box).

  If the system identifier is a URL, the SAX parser must resolve it fully before reporting it to the application.

  Parameters:
    `publicId` - The public identifier of the external entity being referenced, or null if none was supplied.
    `systemId` - The system identifier of the external entity being referenced.
  Returns:
    An InputSource object describing the new input source, or null to request that the parser open a regular URI connection to the system identifier.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - A Java-specific IO exception, possibly the result of creating a new InputStream or Reader for the InputSource.
  See Also:
    `InputSource`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® Application Server XML Java API Reference 10g Release 2 (10.1.2) Part no. B12024-03 September 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD